<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/11/2003 *
 * ===================                          Last change: 07/04/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_emails.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Edit all things around email and sending         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Aendern aller Email-Einstellungen                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Remove empty array index
if (!isPostRequestParameterSet(('max'))) unsetPostRequestParameter(('add_max'));

if (isPostRequestParameterSet(('add_max'))) {
	// Save all settings
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_max_receive` WHERE value='%s' LIMIT 1",
	array(bigintval(postRequestParameter('max'))), __FILE__, __LINE__);
	if (SQL_HASZERONUMS($result)) {
		// Add this value (including comment)
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_max_receive` (value, comment) VALUES ('%s','%s')",
		array(bigintval(postRequestParameter('max')), postRequestParameter('comment')),__FILE__, __LINE__);
		$content = '{--ADMIN_MAX_VALUE_SAVED--}';
	} else {
		// Value does alread exists!
		$content = '<span class="admin_failed">{--ADMIN_MAX_VALUE_ALREADY--}</span>';
	}

	// Free memory
	SQL_FREERESULT($result);

	// Display message
	loadTemplate('admin_settings_saved', false, $content);
} elseif ((isFormSent()) && (isGetRequestParameterSet('do'))) {
	// Change or delete entries...
	$TEXT = '';
	foreach (postRequestParameter('id') as $id => $value) {
		// Secure id
		$id = bigintval($id);

		switch (getRequestParameter('do'))
		{
			case 'edit': // Change entries
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_max_receive` SET value='%s', comment='%s' WHERE `id`=%s LIMIT 1",
				array(
					bigintval(postRequestParameter('val', $id)),
					postRequestParameter('comm', $id),
					$id
				),__FILE__, __LINE__);
				$TEXT = '{--MRECEIVE_SAVED--}';
				break;

			case 'del':
				SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_max_receive` WHERE `id`=%s LIMIT 1",
					array($id), __FILE__, __LINE__);
				$TEXT = '{--MRECEIVE_DELETED--}';
				break;
		}
	}

	if (isset($TEXT)) {
		// Display message
		loadTemplate('admin_settings_saved', false, $TEXT);
	} // END - if
} elseif ((isFormSent('del')) && (countPostSelection() > 0)) {
	// Delete entries
	$OUT = '';
	foreach (postRequestParameter('sel') as $id => $value) {
		// Load data
		$result = SQL_QUERY_ESC("SELECT `id`, `value`, `comment` FROM `{?_MYSQL_PREFIX?}_max_receive` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		$content = SQL_FETCHARRAY($result);
		SQL_FREERESULT($result);

		// Load row template and switch color
		$OUT .= loadTemplate('admin_config_email_del_row', true, $content);
	} // END - foreach
	$content['rows'] = $OUT;

	// Load main template
	loadTemplate('admin_config_email_del', false, $content);
} elseif ((isFormSent('edit')) && (countPostSelection() > 0)) {
	// Edit entries
	$OUT = '';
	foreach (postRequestParameter('sel') as $id => $value) {
		// Load data
		$result = SQL_QUERY_ESC("SELECT `id`, `value`, `comment` FROM `{?_MYSQL_PREFIX?}_max_receive` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		$content = SQL_FETCHARRAY($result);
		SQL_FREERESULT($result);

		// Load row template and switch color
		$OUT .= loadTemplate('admin_config_email_edit_row', true, $content);
	} // END - foreach
	$content['rows'] = $OUT;

	// Load main template
	loadTemplate('admin_config_email_edit', false, $content);
} else {
	$result = SQL_QUERY("SELECT `id`, `value`, `comment` FROM `{?_MYSQL_PREFIX?}_max_receive` ORDER BY `value` ASC",
	__FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// List already existing entries for editing
		$OUT = '';
		while ($content = SQL_FETCHARRAY($result)) {
			// Load row template and switch color
			$OUT .= loadTemplate('admin_config_email_row', true, $content);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);
		$content['rows'] = $OUT;

		// Load main template
		loadTemplate('admin_config_email', false, $content);
	} // END - if

	// Display form
	loadTemplate('admin_add_max');
}

// [EOF]
?>
