<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 03/22/2004 *
 * ===================                          Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-extentions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Extension management                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Erweiterungen-Management                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Normally we want the overview of all registered extensions
$do = 'overview';

if (isGetRequestParameterSet('reg_ext')) {
	// We are about to register a new extension
	$do = 'register'; $taskId = bigintval(getRequestParameter('reg_ext'));
	// The id comes from task management and it is - of course - *not* the extension's name!
} elseif ((isFormSent('change')) && (countPostSelection() > 0) && (!isDemoModeActive())) {
	// De-/activate extensions
	foreach (postRequestParameter('sel') as $taskId => $active) {
		// Shall we keep the extension always active?
		if ((isset($GLOBALS['cache_array']['always_active'][getExtensionName($taskId)])) && ($GLOBALS['cache_array']['always_active'][getExtensionName($taskId)] == 'Y') && ($active == 'Y')) {
			// Keep this extension active!
			loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_EXTENSION_ALWAYS_ACTIVE', getExtensionName($taskId)));
		} else {
			// De/activate extension
			$ACT = 'N'; setExtensionMode('deactivate');
			if ($active != 'Y') { $ACT = 'Y'; setExtensionMode('activate'); }
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_active`='%s' WHERE `id`=%s AND `ext_active`='%s' LIMIT 1",
				array($ACT, bigintval($taskId), $active), __FILE__, __LINE__);

			// Run embeded SQL commands
			doExtensionSqls($taskId, getExtensionMode());
		}
	} // END - foreach

	// Redirect to prevent missing cache in js.php
	redirectToUrl('modules.php?module=admin&amp;what=extensions&amp;changed=' . countPostSelection());
} elseif (((isFormSent('edit')) || (isPostRequestParameterSet('modify'))) && (countPostSelection() > 0) && (!isDemoModeActive())) {
	// Change settings like CSS file load
	if (isPostRequestParameterSet('modify')) {
		// Change entries
		$cache_update = '0';
		foreach (postRequestParameter('sel') as $taskId => $sel) {
			// Secure id
			$taskId = bigintval($taskId);

			// Change this extension?
			if ($sel == 1) {
				// Load mode is modify
				setExtensionMode('modify');

				// Get entry for 'active'
				$active = postRequestParameter('active', $taskId);

				// Update extension's record
				if (isExtensionInstalledAndNewer('sql_patches', '0.0.6')) {
					// Update also CSS column when extensions sql_patches is newer or exact v0.0.6
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_has_css`='%s', `ext_active`='%s' WHERE `id`=%s LIMIT 1",
						array(postRequestParameter('css', $taskId), $active, $taskId), __FILE__, __LINE__);
				} else {
					// When extension is older than v0.0.6 there is no column for the CSS information
					SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_extensions` SET `ext_active`='%s' WHERE `id`=%s LIMIT 1",
						array($active, $taskId), __FILE__, __LINE__);
				}

				// Run SQLs on activation / deactivation
				switch ($active) {
					case 'Y': setExtensionMode('activate');   break;
					case 'N': setExtensionMode('deactivate'); break;
				} // END - if

				// Run embeded SQL commands
				doExtensionSqls($taskId, getExtensionMode());
			}
		}

		// Redirect to prevent missing cache in js.php
		redirectToUrl('modules.php?module=admin&amp;what=extensions&amp;edited=' . countPostSelection());
	} else {
		// Edit selected entries
		$OUT = '';
		foreach (postRequestParameter('sel') as $taskId => $sel) {
			// Edit this extension?
			if (($sel == 'Y') || ($sel != 'Y')) {
				// Default is no CSS for non-updated mailers
				$css = 'N';

				// Load required data
				if (isExtensionInstalledAndNewer('sql_patches', '0.0.6')) {
					$result = SQL_QUERY_ESC("SELECT ext_has_css, ext_active FROM `{?_MYSQL_PREFIX?}_extensions` WHERE `id`=%s LIMIT 1",
						array(bigintval($taskId)), __FILE__, __LINE__);
					list($css, $active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
				} else {
					$result = SQL_QUERY_ESC("SELECT ext_active FROM `{?_MYSQL_PREFIX?}_extensions` WHERE `id`=%s LIMIT 1",
						array(bigintval($taskId)), __FILE__, __LINE__);
					list($active) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
					$css = 'X';
				}

				// Prepare CSS column
				$cssSelection = '---';
				if (isExtensionInstalledAndNewer('sql_patches', '0.0.6')) {
					$cssSelection = addSelectionBox('yn', $css, 'css', $taskId);
				} // END - if

				// Prepare data for the row template
				$content = array(
					'id'     => $taskId,
					'name'   => getExtensionName($taskId),
					'active' => addSelectionBox('yn', $active, 'active', $taskId),
					'css'    => $cssSelection,
				);

				// Load row template and switch color
				$OUT .= loadTemplate('admin_extensions_edit_row', true, $content);
			} // END - if
		} // END - foreach

		// Load template
		loadTemplate('admin_extensions_edit', false, $OUT);
		$do = 'edit';
	}
} elseif ((isPostRequestParameterSet('delete')) && (countPostSelection() > 0) && (!isDemoModeActive())) {
	// List extensions and when verbose is enabled SQL statements which will be executed
	$OUT = '';
	foreach (postRequestParameter('sel') as $taskId => $sel) {
		// Init variables
		$VERBOSE_OUT = '';
		initSqls();

		// Secure id number
		$taskId = bigintval($taskId);

		// Is the id valid?
		if (isExtensionIdValid($taskId)) {
			// Get extension name
			$ext_name = getExtensionName($taskId);

			if (getConfig('verbose_sql') == 'Y') {
				// Load SQL commands in remove mode
				if (loadExtension($ext_name, 'remove', '', true)) {
					// Generate extra table with loaded SQL commands
					$VERBOSE_OUT = addExtensionVerboseSqlTable();
				} // END - if
			} // END - if

			// Prepare data for the row template
			$content = array(
				'id'       => $taskId,
				'ext_name' => $ext_name,
				'ext_ver'  => getExtensionVersion($ext_name),
				'verbose'  => $VERBOSE_OUT
			);

			// Load row template and switch color
			$OUT .= loadTemplate('admin_extensions_delete_row', true, $content);
		} else {
			// Prepare data for the row template
			$content = array(
				'id'       => $taskId
			);

			// Not valid!
			$OUT .= loadTemplate('admin_extensions_delete_row_404', true, $content);
		}
	} // END - foreach

	// Load template
	loadTemplate('admin_extensions_delete', false, $OUT);
	$do = 'delete';
} elseif ((isFormSent('remove')) && (countPostSelection() > 0) && (!isDemoModeActive())) {
	// Remove extensions from DB (you have to delete all files manually!)
	$cache_update = '0';
	foreach (postRequestParameter('sel') as $taskId => $active) {
		// Secure id number
		$taskId = bigintval($taskId);

		// Is this extension selected and id valid?
		if (($active == 1) && (isExtensionIdValid($taskId))) {
			// Run embeded SQL commands
			doExtensionSqls($taskId, 'remove');
		} // END - if
	} // END - foreach

	// Redirect to prevent missing cache in js.php
	redirectToUrl('modules.php?module=admin&amp;what=extensions&amp;removed=' . countPostSelection());
} elseif ((isGetRequestParameterSet('do')) && (!isDemoModeActive())) {
	// Other things to do
	$do = SQL_ESCAPE(secureString(getRequestParameter('do')));
} elseif (isGetRequestParameterSet('do')) {
	// Demo mode active!
	$do = 'demo';
} elseif (isGetRequestParameterSet('registered')) {
	// Extensions changed
	loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_EXTENSION_REGISTERED', getExtensionName(getRequestParameter('registered'))));

	// Show next link
	if (isExtensionActive('task')) {
		loadTemplate('admin_next_link', false, array(
			'url'   => 'modules.php?module=admin&amp;what=list_task',
			'title' => '{--ADMIN_EXTENSION_REGISTER_NEXT_LINK--}'
		));
	} else {
		loadTemplate('admin_next_link', false, array(
			'url'   => 'modules.php?module=admin',
			'title' => '{--ADMIN_EXTENSION_REGISTER_NEXT_LINK--}'
		));
	}
} elseif (isGetRequestParameterSet('changed')) {
	// Extensions changed
	loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_EXTENSION_CHANGED', bigintval(getRequestParameter('changed'))));
} elseif (isGetRequestParameterSet('edited')) {
	// Extensions changed
	loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_EXTENSION_EDITED', bigintval(getRequestParameter('edited'))));
} elseif (isGetRequestParameterSet('removed')) {
	// Extensions changed
	loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_EXTENSIONS_REMOVED', bigintval(getRequestParameter('removed'))));
}

// Shall we display active/inactive extensions?
$where = '';
if (isGetRequestParameterSet(('active'))) {
	$where = sprintf("WHERE `ext_active`='%s'", SQL_ESCAPE(secureString(getRequestParameter('active'))));
} // END - if

// Case selection
switch ($do) {
	case 'overview': // List all registered extensions
		if (isExtensionInstalledAndNewer('sql_patches', '0.0.6')) {
			// Load extension data with CSS informations
			$result = SQL_QUERY("SELECT
	`id` AS ext_id, `ext_name`, `ext_active`, `ext_has_css` AS ext_css, `ext_version`
FROM
	`{?_MYSQL_PREFIX?}_extensions`
".$where."
ORDER BY
	`ext_name` ASC", __FILE__, __LINE__);
		} else {
			// Load extension data without CSS informations
			$result = SQL_QUERY("SELECT
	`id` AS ext_id, `ext_name`, `ext_active, `ext_version`
FROM
	`{?_MYSQL_PREFIX?}_extensions`
".$where."
ORDER BY
	`ext_name` ASC", __FILE__, __LINE__);
		}

		// Are there some entries?
		if (SQL_NUMROWS($result) > 0) {
			// Extensions are registered
			$OUT = '';
			while ($content = SQL_FETCHARRAY($result)) {
				// Prepare CSS selection output
				$cssSelection = '---';
				if (isExtensionInstalledAndNewer('sql_patches', '0.0.6')) $cssSelection = translateYesNo($content['ext_css']);

				// Prepare data for the row template
				$content['ext_css'] = $cssSelection;

				// Load row template and switch color
				$OUT .= loadTemplate('admin_extensions_row', true, $content);
			} // END - while

			// Free memory
			SQL_FREERESULT($result);

			// Load template
			loadTemplate('admin_extensions', false, $OUT);
		} else {
			// No extensions are registered
			loadTemplate('admin_settings_saved', false, '{--ADMIN_NO_EXTENSION_REGISTERED--}');
		}
		break;

	case 'register': // Register new extension
		$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_task_system` WHERE `assigned_admin`=%s AND `task_type`='EXTENSION' LIMIT 1",
			array(getCurrentAdminId()), __FILE__, __LINE__);
		$task_found = SQL_NUMROWS($result);

		// Free result
		SQL_FREERESULT($result);

		// Is the id number valid and the task was found?
		if (($taskId > 0) && ($task_found == 1)) {
			// id is valid so begin with registration, we first want to it's real name from task management (subject column)
			$result = SQL_QUERY_ESC("SELECT `subject` FROM `{?_MYSQL_PREFIX?}_task_system` WHERE `id`=%s LIMIT 1",
				array(bigintval($taskId)), __FILE__, __LINE__);
			list($subject) = SQL_FETCHROW($result);

			// Free result
			SQL_FREERESULT($result);

			// Disable cache update by default
			$cache_update = '0';
			if (!empty($subject)) {
				// Extract extension's name from subject...
				$ext_name = trim(substr($subject, 1, strpos($subject, ':') - 1));

				// Test the extension for deprecation
				loadExtension($ext_name, 'test');

				// Is the extension deprecated?
				if (!isExtensionDeprecated()) {
					// ... so we can finally register and load it in registration mode
					if (registerExtension($ext_name, $taskId)) {
						// Errors?
						if (!ifFatalErrorsDetected()) {
							// Extension was found and successfully registered
							redirectToUrl('modules.php?module=admin&amp;what=extensions&amp;registered=' . getExtensionId($ext_name));
						} else {
							// Errors detected!
							loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_EXTENSION_NOT_REGISTERED', $ext_name));
						}

						// Do we need to update cache file?
						// @TODO Rewrite this to a filter
						if (isExtensionActive('cache')) {
							// Remove cache file (will be auto-created again!)
							if ($GLOBALS['cache_instance']->loadCacheFile('config'))    $GLOBALS['cache_instance']->removeCacheFile();
							if ($GLOBALS['cache_instance']->loadCacheFile('extension')) $GLOBALS['cache_instance']->removeCacheFile();
							if ($GLOBALS['cache_instance']->loadCacheFile('filter'))    $GLOBALS['cache_instance']->removeCacheFile();
							if ($GLOBALS['cache_instance']->loadCacheFile('modules'))   $GLOBALS['cache_instance']->removeCacheFile();
						} // END - if
					} elseif (isExtensionInstalled($ext_name)) {
						// Notify the admin that we have a problem here...
						loadTemplate('admin_settings_saved', false, '{--ADMIN_EXTENSION_REGISTRATION_FAILED_ALREADY--}');
					} else {
						// Notify the admin that we have a problem here...
						loadTemplate('admin_settings_saved', false, getMaskedMessage('ADMIN_EXTENSION_REGISTRATION_FAILED_404', $ext_name));
					}
				} else {
					// Motify the admin that we have a problem here...
					loadTemplate('admin_settings_saved', false, '{--ADMIN_EXTENSION_REGISTRATION_FAILED_DEPRECATED--}');
				}
			} else {
				// Extension was not found in task management
				loadTemplate('admin_settings_saved', false, '{--ADMIN_EXTENSION_REGISTRATION_FAILED_ID_404--}');
			}
		} elseif ($task_found == '0') {
			// No longer assigned or old task
			loadTemplate('admin_settings_saved', false, '{--ADMIN_EXTENSION_REGISTRATION_FAILED_ASSIGED--}');
		} else {
			// id is invalid
			loadTemplate('admin_settings_saved', false, '{--ADMIN_EXTENSION_REGISTRATION_FAILED_INVALID--}');
		}
		break;

	case 'demo':
		loadTemplate('admin_settings_saved', false, '{--SETTINGS_NOT_SAVED--}');
		break;
} // END - switch

// [EOF]
?>
