<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/14/2004 *
 * ===================                          Last change: 06/20/2010 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : monthly_bonus.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Monthly bonus from click-bonus                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Monatlicher Bonus von Klick-Verguetung           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif ((getOutputMode() == 1) || (!isResetModeEnabled())) {
	// Do not execute when script is in CSS mode or no daily reset
	return;
} elseif (!isExtensionActive('bonus')) {
	logDebugMessage(__FILE__, __LINE__, 'Not resetting, needed extension disabled.');
	return;
}

// Get current month (2 digits)
$curr = getMonth();

if (($curr != getConfig('last_month')) && (getConfig('bonus_ranks') > 0) && (getOutputMode() != 1)) {
	// Extension 'autopurge' is inactive or purging of inactive accounts is deactivated
	$whereStatement1 = "WHERE `status`='CONFIRMED'";

	// Shall I keep inactive members away from here? (mostly wanted in an "active-rallye" ...)
	if (isExtensionActive('autopurge')) {
		// Use last online stamp only when autopurge for inactive members is activated
		if (getConfig('ap_inactive_since') > 0) {
			// Okay, include last online timestamp
			$whereStatement1 = "WHERE `status`='CONFIRMED' AND `last_online` >= (UNIX_TIMESTAMP() - {?ap_inactive_since?})";
		} // END - if
	} // END - if

	// Add more bonus points here
	$add = '';
	// @TODO Rewrite this to a filter
	if (getConfig('bonus_click_yn') == 'Y') $add .= ' + `turbo_bonus`';
	if (getConfig('bonus_login_yn') == 'Y') $add .= ' + `login_bonus`';
	if (getConfig('bonus_order_yn') == 'Y') $add .= ' + `bonus_order`';
	if (getConfig('bonus_stats_yn') == 'Y') $add .= ' + `bonus_stats`';
	if (getConfig('bonus_ref_yn')   == 'Y') $add .= ' + `bonus_ref`';

	// Shall we add some entries?
	if (!empty($add)) {
		$whereStatement1 .= ' AND (0' . $add . ') > 0';
	} // END - if

	// Run SQL string to check for accounts
	$result_main = SQL_QUERY("SELECT
	`userid`, `email`, `gender`, `surname`, `family`, (0" . $add . ") AS points
FROM
	`{?_MYSQL_PREFIX?}_user_data`
" . $whereStatement1 . "
ORDER BY
	`points` DESC,
	`userid` ASC
LIMIT {?bonus_ranks?}", __FILE__, __LINE__);

	// Some entries were found?
	if (SQL_NUMROWS($result_main) > 0) {
		// Load our winners...
		while ($content = SQL_FETCHARRAY($result_main)) {
			// Make sure zero points are not mailed
			if ($content['points'] > 0) {
				// Add points to user's account directly
				addPointsDirectly('monthly_bonus', $content['userid'], $content['points']);

				// Load email template and email it away
				$message = loadEmailTemplate('member_bonus', $content, bigintval($content['userid']));
				sendEmail($content['email'], '{--BONUS_MONTHLY_ONLINE_BONUS--}', $message);
			} // END - if
		} // END - while

		// Reset all accounts
		$result = SQL_QUERY('UPDATE `{?_MYSQL_PREFIX?}_user_data`
SET
	`turbo_bonus`=0,
	`login_bonus`=0,
	`bonus_order`=0,
	`bonus_stats`=0,
	`bonus_ref`=0', __FILE__, __LINE__);
	} // END - if

	// Free memory
	SQL_FREERESULT($result_main);
} // END - if

// [EOF]
?>
